<?php
namespace Wordpress\Plugins\CarDealerPress\Inventory\Api;

	$this->compared_vehicles = $this->saved_vehicles = array();
	$content = '';
	
	$seo_hack = array( 'city' => self::$db_company[0]['city'] , 'state' => self::$db_company[0]['state'] , 'country_code' => self::$db_company[0]['country'] );
	$this->seo_headers->apply_headers( $this->parameters, $seo_hack );
	
	// Load Dependent Scripts
	$dependent_scripts = array('jquery','jquery-ui-core','jquery-ui-tabs','jquery-ui-dialog','jquery-ui-slider' );
	foreach( $dependent_scripts as $dependent ) {
		wp_enqueue_script( $dependent );
	}
	wp_enqueue_script( 'cdp_jquery_cookie' , self::$plugin_information[ 'PluginURL' ] . '/application/assets/js/jquery-cookie/js.cookie.js' , array( 'jquery' ) , '2.1.3' );
	
	// Load Save Form
	if( function_exists('gravity_form_enqueue_scripts') ){
		if( $this->options['vehicle_management_system']['theme']['saved_vehicles']['form'] ){
			$gform_element = '<div style="display: none;" id="saved-gform-id" form="'.$this->options['vehicle_management_system']['theme']['saved_vehicles']['form'].'"></div>';
			$gform_class = 'saved_get_gform';
			gravity_form_enqueue_scripts($this->options['vehicle_management_system']['theme']['saved_vehicles']['form'], true);
		}
	}
	
	// Load Page Style/Script 
	$saved_style_url = self::$plugin_information['PluginURL'].'/application/assets/css/inventory/save-page.css';
	$saved_style_url = apply_filters('cdp_save_style_url',$saved_style_url);
	$saved_script_url = self::$plugin_information['PluginURL'].'/application/assets/js/inventory/save-compare.js';
	$saved_script_url = apply_filters('cdp_save_script_url',$saved_script_url);

	wp_enqueue_style( 'cdp_saved', $saved_style_url, array(), self::$plugin_information['Version'] );	
	wp_register_script( 'cdp_saved_js', $saved_script_url, $dependent_scripts, self::$plugin_information['Version'], TRUE );	
	wp_localize_script( 'cdp_saved_js', 'ajax_path', admin_url('admin-ajax.php') );
	wp_enqueue_script( 'cdp_saved_js' );
	
	// Get Save Cookies
	foreach($_COOKIE as $key=>$value){
		if( strpos($key,'vehicleSave') !== FALSE ){
			$this->saved_vehicles[str_replace('CDPvehicleSave_', '', $key)] = $value;
		}
	}
	
	// Get Compare Cookies
	foreach($_COOKIE as $key=>$value){
		if( strpos($key,'vehicleCompare') !== FALSE ){
			$this->compared_vehicles[str_replace('CDPvehicleCompare_', '', $key)] = $value;
		}
	}
	
	// Build Save Display
	$content .= '<div id="saved-vehicle-container">';
	if( !empty($this->saved_vehicles) ){
		$content .= '<div id="saved-vehicle-inner-container">';
		foreach( $this->saved_vehicles as $key=>$values ){
			$vehicleRaw = cdp_plugin::$db_caller->cdp_db_init('inventory', array('vin'=>$key) );
			
			$savedData = json_decode(stripslashes($values));
			if( !empty($vehicleRaw) ){
				$vehicle = $vehicleRaw[0];
				$content .= '<div id="'.$key.'" class="saved-vehicle-item">'; // saved-vehicle-item Open
					$content .=  '<div class="saved-vehicle-content">'; // saved-vehicle-content Open
						$content .= '<div class="saved-left-content">'; // saved-left-content Open
							$image = $vehicle['thumbnail'];
							if( (empty($image) || strstr($image,'_no_photo')) && !empty($this->options['vehicle_management_system']['data']['default_no_image']) ){
								$image = $this->options['vehicle_management_system']['data']['default_no_image'];
							}
		
							if( strpos($image, 'images.dealertrend.com') !== FALSE ){
								$image = str_replace('http://images.dealertrend.com', 'https://s3.amazonaws.com/images.dealertrend.com', $image);
							}
							$content .= '<img class="saved-vehicle-image" src="'.str_replace('_small', '_medium', $image ).'" />';
						$content .= '</div>'; // saved-left-content Close
					
						$content .= '<div class="saved-right-content">'; // saved-right-content Open
							$content .= '<div key="CDPvehicleSave_'.$key.'" class="saved-remove right-item">Remove [X]</div>';
							$content .= '<div class="saved-headline">';
								$content .= '<span class="saleclass form-value" name="saleclass">'.ucfirst($vehicle['saleclass']).'</span>';
								$content .= '<span class="year form-value" name="year">'.$vehicle['year'].'</span>';
								$content .= '<span class="make form-value" name="make">'.$vehicle['make'].'</span>';
								$content .= '<span class="model form-value" name="model">'.$vehicle['model'].'</span>';
								$content .= '<span class="trim form-value" name="trim">'.$vehicle['trim'].'</span>';
							$content .= '</div>';
							$content .= '<div class="saved-hidden-values" style="display: none;">';
								$content .= '<span class="form-value" name="stock">'.$vehicle['stock'].'</span>';
								$content .= '<span class="form-value" name="vin">'.$vehicle['vin'].'</span>';
								$content .= '<span class="form-value" name="exterior">'.$vehicle['exterior'].'</span>';
								$content .= '<span class="form-value" name="interior">'.$vehicle['interior'].'</span>';
								$content .= '<span class="form-value" name="odometer">'.$vehicle['odometer'].'</span>';
								$phone_number = ( !empty($this->options['vehicle_management_system']['custom_contact']['phone'][strtolower($vehicle['saleclass'])])? $this->options['vehicle_management_system']['custom_contact']['phone'][strtolower($vehicle['saleclass'])] : self::$db_company[0]['phone'] );
								$dealer_name = ( !empty($this->options['vehicle_management_system']['custom_contact']['contact_name'][strtolower($vehicle['saleclass'])])? $this->options['vehicle_management_system']['custom_contact']['contact_name'][strtolower($vehicle['saleclass'])] : self::$db_company[0]['name'] );
								$content .= '<span class="form-value" name="dealer">'.$dealer_name.'</span>';
								$content .= '<span class="form-value" name="phone">'.$phone_number.'</span>';
								$content .= '<span class="form-value" name="dealer_id">'.self::$db_company[0]['dealer_id'].'</span>';
								$content .= '<span class="form-value" name="location">'.self::$db_company[0]['street'].' '.self::$db_company[0]['city'].' '.self::$db_company[0]['state'].' '.self::$db_company[0]['zip'].'</span>';
								$content .= '<span class="form-value" name="dealer_id">'.self::$db_company[0]['dealer_id'].'</span>';
								$content .= get_automall_email(self::$db_company[0]['dealer_id'], $vehicle['saleclass']);
								$content .= '<span class="is-adf form-value" name="is_adf" >'.get_automall_email_adf(self::$db_company[0]['dealer_id'], $vehicle['saleclass']).'</span>';
							$content .= '</div>';
							$content .= '<div class="saved-buttons">';
								$content .= '<div class="saved-more-details"><a href="'.$savedData->link.'">More Details</a></div>';
								if( !empty($this->options['vehicle_management_system']['theme']['saved_vehicles']['form']) ){
									$content .= '<div class="saved-form-action" key="'.$vehicle['vin'].'">Get Today\'s Price</div>';
								}
								
								if( !empty($this->compared_vehicles) ){
									$compareClass = ( array_key_exists($vehicle['vin'], $this->compared_vehicles)? 'checked': '' );
								} else {
									$compareClass = '';
								}
								
								$content .= '<div class="saved-compare-vehicles-container">';
									$content .= '<div class="inventory-vehicle-compare '.$compareClass.'">';
										$content .= '<span class="compare-text">'.( empty($compareClass)? 'Compare Vehicle': 'Remove Compare' ).'</span>';
										$content .= '<span class="compare-checkbox">'.( empty($compareClass)? '': 'X' ).'</span>';
									$content .= '</div>';
								$content .= '</div>';
								
							$content .= '</div>';
							$content .= '<div class="saved-prices">'; // saved-prices Open
								preg_match( '/\$\d*(\s)?/' , $vehicle['ais_text'] , $incentive );
								$ais_value = (isset( $incentive[0] ) ? str_replace( '$' , NULL, $incentive[0] ) : 0);
								$dbprices = array(
									'was_now'=>TRUE,
									'strike_through'=>TRUE,
									'on_sale'=>($vehicle['saleprice'] < $vehicle['askingprice']? TRUE: FALSE),
									'asking_price'=>$vehicle['askingprice'],
									'sale_price'=>$vehicle['saleprice'],
									'sale_expire'=>$vehicle['sale_expire'],
									'retail_price'=>$vehicle['retailprice'],
									'default_text'=>'Call for price',
									'ais'=> array('text'=>$vehicle['ais_text'],'value'=>$ais_value)
							
								);
								$price = get_price_display($dbprices, self::$db_company[0], $vehicle['saleclass'], $vehicle['vin'], 'saved', $this->options['vehicle_management_system']['theme']['price_text'] );
								
								$content .= '<div class="saved-vehicle-pricing">';	// saved-vehicle-pricing Open
									$content .= ( empty($price['msrp_text']) || strtolower($vehicle['saleclass']) != 'new' ? '': '<div class="price-item price-msrp">'.$price['msrp_text'].'</div>');
									//First Discount if AIS and New and Has MSRP
									$content .= ( !empty($vehicle['prices']['retail_price']) && $price['ais_text'] && $price['discount_text']? '<div class="price-item price-discount">'.$price['discount_text'].'</div>': '');
									$content .= ( empty($price['compare_text'])? '': '<div class="price-item price-compare">'.$price['compare_text'].'</div>');
									//Second Discount if AIS or Sale Price listed
									$content .= ( empty($price['ais_text'])? ( empty($price['discount_text'])? '': '<div class="price-item price-discount">'.$price['discount_text'].'</div>'): '<div class="price-item price-ais">'.$price['ais_text'].'</div>');
									$content .= (empty($price['ais_link']))? '': '<div class="price-item price-ais-link">'.$price['ais_link'].'</div>';

									$content .= ( empty($price['primary_text'])? '': '<div class="price-item price-primary">'.$price['primary_text'].'</div>');
									$content .= ( empty($price['expire_text'])? '': '<div class="price-item price-expire">'.$price['expire_text'].'</div>');
									$content .= '<div class="price-item price-hidden-values">'.$price['hidden_prices'].'</div>';
								$content .= '</div>'; // saved-vehicle-pricing Close
							$content .= '</div>'; // saved-price Close
							$content .= '<div class="saved-vehicle-form-holder" style="display: none;"></div>';
						$content .= '</div>'; // saved-right-content Close
					$content .= '</div>'; // saved-vehicle-content Close
					$content .= '<div class="removed-saved-vehicle-content" style="display: none;">'; // removed-saved-vehicle-content Open
						$content .= '<div class="removed-vehicle-headline">'; // removed-vehicle-headline Open
							$content .= '<span name="saleclass" class="removed-item removed-saleclass">'.ucfirst($vehicle['saleclass']).'</span>';
							$content .= '<span name="year" class="removed-item removed-year">'.$vehicle['year'].'</span>';
							$content .= '<span name="make" class="removed-item removed-make">'.$vehicle['make'].'</span>';
							$content .= '<span name="model" class="removed-item removed-model">'.$vehicle['model'].'</span>';
							$content .= '<span name="trim" class="removed-item removed-trim" style="display: none">'.$vehicle['trim'].'</span>';
							$content .= '<span name="image" class="removed-item removed-image" style="display: none">'.$image.'</span>';
							$content .= '<span name="link" class="removed-item removed-link" style="display: none">'.$savedData->link.'</span>';
							$content .= '<span name="price" class="removed-item removed-price" style="display: none">'.$price['primary_price'].'</span>'; 
							$content .= 'has been removed.';
							$content .= '<div key="CDPvehicleSave_'.$key.'" class="restore-saved-vehicle">Restore Removed Vehicle</div>'; // Open/Close
						$content .= '</div>'; // removed-vehicle-headline Close
					$content .= '</div>'; //removed-saved-vehicle-content Close
				$content .= '</div>'; // saved-vehicle-item Close
			}
		}
		$content .= '</div>';
		// Build Compare Display
		$i = 1;
		$class = ( count($this->compared_vehicles) > 0? 'visible': 'empty');
		$content .= '<div id="compare-vehicle-container" class="'.$class.'">';
			$content .= '<div id="compare-under-count" style="display: none;">At least two vehicles must be selected before comparing.</div>';
			$content .= '<div id="compare-over-count" style="display: none;">Can only compare 5 vehicles at a time. Remove before adding a new vehicle.</div>';
			if( count($this->compared_vehicles) > 0 ){
				foreach($this->compared_vehicles as $key=>$values){
					$data = json_decode(stripslashes($values));
					$content .= '<div class="compare-item item-'.$i.' compare-'.$key.'">';
						$content .= '<div class="compare-main"><img src="'.$data->image.'" /></div>';
						$content .= '<div class="compare-sub" style="display: none;">';
							$content .= '<span class="compare-saleclass">'.$data->saleclass.'</span>';
							$content .= '<span class="compare-year">'.$data->year.'</span>';
							$content .= '</br><span class="compare-make">'.$data->make.'</span>';
							$content .= '<span class="compare-model">'.$data->model.'</span>';
							$content .= '</br><span class="compare-trim">'.$data->trim.'</span>';
						$content .= '</div>';
						$content .= '<div class="compare-remove" key="'.$key.'">Remove [X]</div>';
					$content .= '</div>';
					$i++;
				}
			}
			while ($i <= 5){ // Only load 5 spaces
				$content .=  '<div class="compare-item item-'.$i.' empty"></div>';
				$i++;
			}
			$content .= '<div id="compare-vehicle-count-container" class="compare-item"><div id="compare-button">View Compared</br>Vehicles (<span id="compare-vehicle-count">'.count($this->compared_vehicles).'</span>)</div></div>';
		$content .= '</div>';
		
		
	} else {
		$content .= '<div id="saved-not-found">No Vehicles have been saved or are no longer saved.</div>';
	}
	$content .= '</div>';
	
	get_header();
	echo $content;
	echo !empty($gform_element) ? $gform_element: '';
	get_footer();
?>